from math import *
from random import *
from constants import *

# Effect
# Effect is a particle, or a circle in this case, with given size and speed.

class Effect():
    def __init__(self, eType, x, y, r, drop, direction, speed):
        self.eType = eType
        self.x = x
        self.y = y
        self.direction = direction
        self.speed = speed
        self.life = 1
        self.r = r
        self.drop = drop
        self.alpha = 1
        self.falling = 0
        self.flip = randint(0,1)
        
        if self.eType == 'brick':
            self.image = randint(1,imageAmount['brick'])
            self.angle = 2 * pi * random()
            self.rotation = pi / 10.0 * (-0.5 + random())
        if self.eType == 'flare':
            self.image = randint(1,imageAmount['flare'])
            self.angle = pi + self.direction - 0.2
            self.rotation = 0
        if self.eType == 'cloud':
            self.image = randint(1,imageAmount['cloud'])
            self.angle = 0
            self.rotation = 0

    def update(self):
	self.move()
	self.life -= self.drop
        if self.eType == 'brick':
            self.falling += 0.15
        self.angle += self.rotation
    
    def move(self):
        self.x += self.speed * sin(self.direction)
    	self.y += self.speed * cos(self.direction)
        self.y += self.falling

    def getAlpha(self):
        return int(255 * self.life)
        
    def isAlive(self):
        return self.life > 0
